import * as _loadable_component from '@loadable/component';
import { DefaultComponent, Options, ExtraComponentProps } from '@loadable/component';
import React from 'react';

declare type LoadFn<Props> = (props: Props) => Promise<DefaultComponent<Props>>;
declare type LoadOptions<Props> = Options<Props> | undefined;
declare type WrapperProps = {
    wrapperCss?: {
        [key: string]: string | number;
    };
};
declare type AnyProps = {
    [x: string]: any;
};
declare type OnVisibleComponentProps<Props> = Props & AnyProps & WrapperProps & ExtraComponentProps;
declare type ObserverOptions = {
    root?: Element | Document;
    rootMargin?: string;
    threshold?: number | number[];
};
declare type VisibleHandler = () => void;
declare type InitObserverTuple = [Map<Element, VisibleHandler>, IntersectionObserver | undefined];

declare function initComponent<Props>(loadFn: LoadFn<Props>, opts?: LoadOptions<Props>): _loadable_component.LoadableComponent<Props> | {
    (props: OnVisibleComponentProps<Props>): JSX.Element;
    preload(): void;
    load(): Promise<React.ComponentType<Props>>;
};

declare function initObserver(observerOptions?: ObserverOptions): InitObserverTuple;

export { AnyProps, InitObserverTuple, LoadFn, LoadOptions, ObserverOptions, OnVisibleComponentProps, VisibleHandler, WrapperProps, initComponent as default, initObserver };
